[libvirt] [PATCH] fix just-broken "virsh start" and "virsh pool-start" commands

Jim Meyering jim at meyering.net
Tue Dec 9 17:35:29 UTC 2008


* src/virsh.c (cmdPoolStart, cmdStart): Change hard-coded
vshCommandOptDomainBy string argument to match just-changed
option name.  Cole Robinson reported that "virsh start" was
broken and provided that part of the fix.
Bug introduced by yesterday's "virsh.c: tweak options to produce
more accurate help".
* tests/start: New file.  Test for the above fix.
* tests/Makefile.am (test_scripts): Add start.
---

Without this change, "virsh start" and "virsh pool-start"
would always fail.

I'm fixing this in two steps: first is this patch: make the tiny
string-changing fixes (along with the new test).
Second will be a more invasive change to make it so the duplicate
strings are removed altogether, so they'll never get out of sync again.


 src/virsh.c       |    4 ++--
 tests/Makefile.am |    1 +
 tests/start       |   42 ++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 45 insertions(+), 2 deletions(-)
 create mode 100755 tests/start

diff --git a/src/virsh.c b/src/virsh.c
index bb81f25..1a5b42f 100644
--- a/src/virsh.c
+++ b/src/virsh.c
@@ -1021,7 +1021,7 @@ cmdStart(vshControl *ctl, const vshCmd *cmd)
     if (!vshConnectionUsability(ctl, ctl->conn, TRUE))
         return FALSE;

-    if (!(dom = vshCommandOptDomainBy(ctl, cmd, "name", NULL, VSH_BYNAME)))
+    if (!(dom = vshCommandOptDomainBy(ctl, cmd, "domain", NULL, VSH_BYNAME)))
         return FALSE;

     if (virDomainGetID(dom) != (unsigned int)-1) {
@@ -3693,7 +3693,7 @@ cmdPoolStart(vshControl *ctl, const vshCmd *cmd)
     if (!vshConnectionUsability(ctl, ctl->conn, TRUE))
         return FALSE;

-    if (!(pool = vshCommandOptPoolBy(ctl, cmd, "name", NULL, VSH_BYNAME)))
+    if (!(pool = vshCommandOptPoolBy(ctl, cmd, "pool", NULL, VSH_BYNAME)))
          return FALSE;

     if (virStoragePoolCreate(pool, 0) == 0) {
diff --git a/tests/Makefile.am b/tests/Makefile.am
index fd319e1..9e794c5 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -64,6 +64,7 @@ test_scripts += \
 	int-overflow \
 	read-bufsiz \
 	read-non-seekable \
+	start \
 	undefine \
 	vcpupin
 	virsh-all
diff --git a/tests/start b/tests/start
new file mode 100755
index 0000000..a436f9b
--- /dev/null
+++ b/tests/start
@@ -0,0 +1,42 @@
+#!/bin/sh
+# ensure that virsh start works properly
+
+# Copyright (C) 2008 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  virsh --version
+fi
+
+test -z "$srcdir" && srcdir=$(pwd)
+test -z "$abs_top_srcdir" && abs_top_srcdir=$(pwd)/..
+. "$srcdir/test-lib.sh"
+
+fail=0
+
+test_url=test:///default
+
+# expect this to fail
+virsh -c $test_url start test > out 2> err && fail=1
+
+# stdout gets a newline
+echo > exp || fail=1
+compare out exp || fail=1
+
+echo 'error: Domain is already active' > exp || fail=1
+compare err exp || fail=1
+
+(exit $fail); exit $fail
--
1.6.0.4.1044.g77718




More information about the libvir-list mailing list